%This code calculates the principle
%component analysis of monthly treasury yield curve
%changes between 2006 and early 2010

%in other works percentage of movement that is parallel, twist, and
%butterfly....and others with diminishing explanatory power.

%This loads the yield curve data stored in data.mat 
%The variable data shows up in the workspace
load data

%This calculates the monthly changes in the yields for the entire set
dailychanges=data(2:end,:)-data(1:end-1,:);
dailychanges=dailychanges(:,4:end);

%This calculates the correlation matrix of the daily changes
corrma=corrcoef(dailychanges);

%This calculates the eigenvalues of the correlation matrix
[vec,val]=eig(corrma);
dims = length(val);

%The percentage of each loading to the total represents the percentage
%of the curves shift to each component- shift, twist, butterfly, etc. in
%descending order.  Usually the first three components will explain the
%majority of the yield curve movement.
percom = diag(val)/sum(diag(val));
percom = sort(percom,'descend')









